package entities;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;

@Entity
//@DiscriminatorValue("EXPIRY")
public class ExpiryEvent extends Event {

	@OneToOne(optional = true)
    @JoinColumn(name = "BATCH_ID")
    private Batch batch;

    @OneToOne(optional = true)
    @JoinColumn(name = "RAW_MATERIAL_ID")
    private RawMaterial rawMaterial;

	public Batch getBatch() {
		return batch;
	}

	public void setBatch(Batch batch) {
		if (batch != null) {
            this.rawMaterial = null; // Clear rawMaterial if batch is being set
        }
        this.batch = batch;
	}

	public RawMaterial getRawMaterial() {
		return rawMaterial;
	}

	public void setRawMaterial(RawMaterial rawMaterial) {
		if (rawMaterial != null) {
            this.batch = null; // Clear batch if rawMaterial is being set
        }
        this.rawMaterial = rawMaterial;
	}
	
}
