package entities;

import java.util.List;

import javax.persistence.*;


@Entity
@Table(name="PROVIDERS")
public class Provider {
	
	//Attributes
	@Id @GeneratedValue
	@Column(name="PROVIDER_ID")
	private long id;
	
	@Column(nullable=false)
	private String cuit;
	
	@Column(nullable=false)
	private String name;
	
	@Column(nullable=false)
	private String description;
	
	@Column(nullable=false)
	private String email;
	
	@Column(nullable=false)
	private String phone;
	
	@Column(nullable=false)
	private String address;
	
	//Relations
	@OneToMany(mappedBy = "provider")
	private List<RawMaterial> rawMaterials;
	
	@OneToMany(mappedBy = "provider")
	private List<Input> inputs;
	
	public Provider() {
		super();
	}

	//Getters and Setters
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getCuit() {
		return cuit;
	}

	public void setCuit(String cuit) {
		this.cuit = cuit;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public List<RawMaterial> getRawMaterials() {
		return rawMaterials;
	}

	public void setRawMaterials(List<RawMaterial> rawMaterials) {
		this.rawMaterials = rawMaterials;
	}

	public List<Input> getInputs() {
		return inputs;
	}

	public void setInputs(List<Input> inputs) {
		this.inputs = inputs;
	}

	@Override
	public String toString() {
		return "Provider [id=" + id + ", cuit=" + cuit + ", name=" + name + ", description=" + description + ", email="
				+ email + ", phone=" + phone + ", address=" + address + "]";
	}
	
	
}
