package entities;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import javax.persistence.*;


@Entity
@Table(name="RECIPES")
public class Recipe {
	

	//Attributes
	@Id @GeneratedValue
	@Column(name="RECIPE_ID")
	private long id;
	
	@Column(nullable=false)
	private String name;
	
	@Column(nullable=false)
	private String description;
	
	//Relations
	@Column(nullable=false)
	private String recipeIngredients;
	
	
	@Column(nullable=false)
	private String recipePackagingElements;
	
	@OneToMany(mappedBy="recipe")
	private List<Batch> batches;
	
	public Recipe() {
		super();
	}

	//Getters and Setters
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public List<Batch> getBatches() {
		return batches;
	}

	public void setBatches(List<Batch> batches) {
		this.batches = batches;
	}

	public String getRecipeIngredients() {
		return recipeIngredients;
	}

	public void setRecipeIngredients(String recipeIngredients) {
		this.recipeIngredients = recipeIngredients;
	}

	public String getRecipePackagingElements() {
		return recipePackagingElements;
	}

	public void setRecipePackagingElements(String recipePackagingElements) {
		this.recipePackagingElements = recipePackagingElements;
	}

	@Override
	public String toString() {
		return "Recipe [id=" + id + ", name=" + name + ", description=" + description + ", recipeIngredients="
				+ recipeIngredients + ", recipePackagingElements=" + recipePackagingElements + "]";
	}

	
}
